# `mopidy.audio` — Audio API

The audio API is the interface we have built around GStreamer to support our specific use cases. Most backends should be able to get by with simply setting the URI of the resource they want to play, for these cases the default playback provider should be used.

For more advanced cases such as when the raw audio data is delivered outside of GStreamer or the backend needs to add metadata to the currently playing resource, developers should sub-class the base playback provider and implement the extra behaviour that is needed through the following API:

class mopidy.audio.Audio(config, mixer)

  Audio output through GStreamer.

  emit_data(buffer_)

    Call this to deliver raw audio data to be played.

    If the buffer is `None`, the end-of-stream token is put on the playbin. We will get a GStreamer message when the stream playback reaches the token, and can then do any end-of-stream related tasks.

    Note that the URI must be set to `appsrc://` for this to work.

    Returns `True` if data was delivered.

    Parameters:

      buffer (`Gst.Buffer` or `None`) – buffer to pass to appsrc

    Return type:

      boolean

  enable_sync_handler()

    Enable manual processing of messages from bus.

    Should only be used by tests.

  get_current_tags()

    Get the currently playing media’s tags.

    If no tags have been found, or nothing is playing this returns an empty dictionary. For each set of tags we collect a tags_changed event is emitted with the keys of the changes tags. After such calls users may call this function to get the updated values.

    Return type:

      {key: [values]} dict for the current media.

  get_position()

    Get position in milliseconds.

    Return type:

      int

  mixer = None

    The software mixing interface `mopidy.audio.actor.SoftwareMixer`

  on_start()

    Run code at the beginning of the actor’s life.

    Hook for doing any setup that should be done after the actor is started, but before it starts processing messages.

    For `ThreadingActor`, this method is executed in the actor’s own thread, while `__init__()` is executed in the thread that created the actor.

    If an exception is raised by this method the stack trace will be logged, and the actor will stop.

  on_stop()

    Run code at the end of the actor’s life.

    Hook for doing any cleanup that should be done after the actor has processed the last message, and before the actor stops.

    This hook is not called when the actor stops because of an unhandled exception. In that case, the `on_failure()` hook is called instead.

    For `ThreadingActor` this method is executed in the actor’s own thread, immediately before the thread exits.

    If an exception is raised by this method the stack trace will be logged, and the actor will stop.

  pause_playback()

    Notify GStreamer that it should pause playback.

    Return type:

      `True` if successfull, else `False`

  prepare_change()

    Notify GStreamer that we are about to change state of playback.

    This function MUST be called before changing URIs or doing changes like updating data that is being pushed. The reason for this is that GStreamer will reset all its state when it changes to `Gst.State.READY`.

  set_about_to_finish_callback(callback)

    Configure audio to use an about-to-finish callback.

    This should be used to achieve gapless playback. For this to work the callback MUST call `set_uri()` with the new URI to play and block until this call has been made. `prepare_change()` is not needed before `set_uri()` in this one special case.

    Parameters:

      callback (callable) – Callback to run when we need the next URI.

  set_appsrc(caps, need_data=None, enough_data=None, seek_data=None)

    Switch to using appsrc for getting audio to be played.

    You MUST call `prepare_change()` before calling this method.

    Parameters:

      - caps (string) – GStreamer caps string describing the audio format to expect

      - need_data (callable which takes data length hint in ms) – callback for when appsrc needs data

      - enough_data (callable) – callback for when appsrc has enough data

      - seek_data (callable which takes time position in ms) – callback for when data from a new position is needed to continue playback

  set_metadata(track)

    Set track metadata for currently playing song.

    Only needs to be called by sources such as `appsrc` which do not already inject tags in playbin, e.g. when using `emit_data()` to deliver raw audio data to GStreamer.

    Parameters:

      track (`mopidy.models.Track`) – the current track

  set_position(position)

    Set position in milliseconds.

    Parameters:

      position (int) – the position in milliseconds

    Return type:

      `True` if successful, else `False`

  set_source_setup_callback(callback)

    Configure audio to use a source-setup callback.

    This should be used to modify source-specific properties such as login details.

    Parameters:

      callback (callable) – Callback to run when we setup the source.

  set_uri(uri, live_stream=False, download=False)

    Set URI of audio to be played.

    You MUST call `prepare_change()` before calling this method.

    Parameters:

      - uri (string) – the URI to play

      - live_stream (bool) – disables buffering, reducing latency for stream, and discarding data when paused

      - download (bool) – enables “download” buffering mode

  start_playback()

    Notify GStreamer that it should start playback.

    Return type:

      `True` if successfull, else `False`

  state = 'stopped'

    The GStreamer state mapped to `mopidy.audio.PlaybackState`

  stop_playback()

    Notify GStreamer that is should stop playback.

    Return type:

      `True` if successfull, else `False`

  wait_for_state_change()

    Block until any pending state changes are complete.

    Should only be used by tests.

## Audio listener

class mopidy.audio.AudioListener

  Marker interface for recipients of events sent by the audio actor.

  Any Pykka actor that mixes in this class will receive calls to the methods defined here when the corresponding events happen in the core actor. This interface is used both for looking up what actors to notify of the events, and for providing default implementations for those listeners that are not interested in all events.

  position_changed(position)

    Called whenever the position of the stream changes.

    MAY be implemented by actor.

    Parameters:

      position (int) – Position in milliseconds.

  reached_end_of_stream()

    Called whenever the end of the audio stream is reached.

    MAY be implemented by actor.

  static send(event, **kwargs)

    Helper to allow calling of audio listener events

  state_changed(old_state, new_state, target_state)

    Called after the playback state have changed.

    Will be called for both immediate and async state changes in GStreamer.

    Target state is used to when we should be in the target state, but temporarily need to switch to an other state. A typical example of this is buffering. When this happens an event with old=PLAYING, new=PAUSED, target=PLAYING will be emitted. Once we have caught up a old=PAUSED, new=PLAYING, target=None event will be be generated.

    Regular state changes will not have target state set as they are final states which should be stable.

    MAY be implemented by actor.

    Parameters:

      - old_state (string from `mopidy.core.PlaybackState` field) – the state before the change

      - new_state (string from `mopidy.core.PlaybackState` field) – the state after the change

      - target_state (string from `mopidy.core.PlaybackState` field or `None` if this is a final state.) – the intended state

  stream_changed(uri)

    Called whenever the audio stream changes.

    MAY be implemented by actor.

    Parameters:

      uri (string) – URI the stream has started playing.

  tags_changed(tags)

    Called whenever the current audio stream’s tags change.

    This event signals that some track metadata has been updated. This can be metadata such as artists, titles, organization, or details about the actual audio such as bit-rates, numbers of channels etc.

    For the available tag keys please refer to GStreamer documentation for tags.

    MAY be implemented by actor.

    Parameters:

      tags (`set` of strings) – The tags that have just been updated.

## Audio scanner

class mopidy.audio.scan.Scanner(timeout=1000, proxy_config=None)

  Helper to get tags and other relevant info from URIs.

  Parameters:

    - timeout – timeout for scanning a URI in ms

    - proxy_config – dictionary containing proxy config strings.

  scan(uri, timeout=None)

    Scan the given uri collecting relevant metadata.

    Parameters:

      - uri (string) – URI of the resource to scan.

      - timeout (int) – timeout for scanning a URI in ms. Defaults to the `timeout` value used when creating the scanner.

    Returns:

      A named tuple containing `(uri, tags, duration, seekable, mime)`. `tags` is a dictionary of lists for all the tags we found. `duration` is the length of the URI in milliseconds, or `None` if the URI has no duration. `seekable` is boolean. indicating if a seek would succeed.

## Audio utils

class mopidy.audio.utils.Signals

  Helper for tracking gobject signal registrations

  clear()

    Clear all registered signal handlers.

  connect(element, event, func, *args)

    Connect a function + args to signal event on an element.

    Each event may only be handled by one callback in this implementation.

  disconnect(element, event)

    Disconnect whatever handler we have for an element+event pair.

    Does nothing it the handler has already been removed.

mopidy.audio.utils.calculate_duration(num_samples, sample_rate)

  Determine duration of samples using GStreamer helper for precise math.

mopidy.audio.utils.clocktime_to_millisecond(value)

  Convert an internal GStreamer time to millisecond time.

mopidy.audio.utils.create_buffer(data, timestamp=None, duration=None)

  Create a new GStreamer buffer based on provided data.

  Mainly intended to keep gst imports out of non-audio modules.

  Changed in version 2.0: `capabilites` argument was removed.

mopidy.audio.utils.millisecond_to_clocktime(value)

  Convert a millisecond time to internal GStreamer time.

mopidy.audio.utils.setup_proxy(element, config)

  Configure a GStreamer element with proxy settings.

  Parameters:

    - element (`Gst.GstElement`) – element to setup proxy in.

    - config (`dict`) – proxy settings to use.

mopidy.audio.utils.supported_uri_schemes(uri_schemes)

  Determine which URIs we can actually support from provided whitelist.

  Parameters:

    uri_schemes (list or set or URI schemes as strings.) – list/set of URIs to check support for.

  Return type:

    set of URI schemes we can support via this GStreamer install.